if(!dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.configHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.configHelper"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.freeformlayout.configHelper");

dojo.require("com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil");

dojo.declare("com.ibm.mm.builder.iwidget.freeformlayout.configHelper",null,{

	_iContext:null,
	
	//WID equals "_"+widgetId+"_". 
	WID:null,
	
	colorPickerHeight:0,
	colorPickerAdjustPosX: 0,
	colorPickerAdjustPosY: 19,
		
	freeformDnDSource:null,
	
	freeformEditPane:null,
	
	colorPicker:null,
	
	backgroundImageType:"",
	
	applyDSToAll:"0",
	previousDefaultSkin:null,
	
	configIconMouseOverHandler:null,
	configIconMouseOutHandler:null,
	configIconOnFocusHandler:null,
	currentPageMode:"view",
	
	constructor:function(iContext,WID){
		this._iContext = iContext;
		this.WID = WID;
	},
		
	getPageProperties : function(att){
		var pageProp = {};
		pageProp.backgroundimagetype = att.getItemValue("backgroundimagetype");
		pageProp.backgroundimage = att.getItemValue("backgroundimage");
		pageProp.backgroundimageproperty = att.getItemValue("backgroundimageproperty");
		pageProp.backgroundimagetransparency = att.getItemValue("backgroundimagetransparency");
		pageProp.pagebgcolor = att.getItemValue("pagebgcolor");
		pageProp.pageborderstyle = att.getItemValue("pageborderstyle");	 
		pageProp.pagebordercolor = att.getItemValue("pagebordercolor");	
		pageProp.pagemargin = att.getItemValue("pagemargin");
		pageProp.pageWidthMode = att.getItemValue("pageWidthMode");
		pageProp.pageWidth = att.getItemValue("pageWidth");
		return pageProp;	
	},
		
	getWidgetProperties : function(att){
		var widgetProp = {};
		widgetProp.skin = att.getItemValue("skin");
		widgetProp.applyDefaultSkinToAll = att.getItemValue("applyDefaultSkinToAll");
		return widgetProp;	
	},
	
	showConfigurationIcon:function(){
		if (this.currentPageMode != "edit") {
			return;
		} 
		
		clearTimeout(this.showConfigurationIconTimer);
		this.showConfigurationIconTimer = window.setTimeout(dojo.hitch(this, function(){
			dojo.style(this.WID + "configIcon", "display", "");
		}),40);
	},
	
	hideConfigurationIcon:function(){
		clearTimeout(this.hideConfigurationIconTimer);
		this.hideConfigurationIconTimer = window.setTimeout(dojo.hitch(this, function(){
			dojo.style(this.WID + "configIcon", "display", "none");
		}),40);
	},
		
	setPageProperties : function(/*boolean*/init,pageProperties){
		var bgitype,bgi,bgiproperty,bgitransparency,bgcolor,pageborderstyle,pagebordercolor,pagemargin,skin;	
		if (pageProperties !== null) {
			bgitype = pageProperties.backgroundimagetype;
			bgi = pageProperties.backgroundimage;
			bgiproperty = pageProperties.backgroundimageproperty;
			bgitransparency = pageProperties.backgroundimagetransparency;
			bgcolor = pageProperties.pagebgcolor;
			pageborderstyle = pageProperties.pageborderstyle;	 
			pagebordercolor = pageProperties.pagebordercolor;	
			pagemargin = pageProperties.pagemargin;				
		}
		this.backgroundImageType = bgitype;
		var selectNone = false;
		var selectURL = false;
		var moreProp;
		if (bgitype == "URL"){
			selectURL = true;
			dojo.byId(this.WID + "pageBgImageURL_input").value = bgi;
			moreProp = dojo.byId(this.WID + "urlMoreProperties");
			moreProp.style.display = "";
		}else{
			selectNone = true;
			moreProp = dojo.byId(this.WID + "urlMoreProperties");
			moreProp.style.display = "none";
		}	
		var noneTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BACKGROUND_IMAGE + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_NONE;
		dojo.byId(this.WID + "pageBgImageNone").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"BGIType","0","eval(" + this.WID + "iContext.iScope().selectBGINone())",selectNone,noneTitle);
		var urlTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BACKGROUND_IMAGE + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_URL;
		dojo.byId(this.WID + "pageBgImageURL").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"BGIType","1","eval(" + this.WID + "iContext.iScope().selectBGIURL())",selectURL,urlTitle);	
		var bgColorIndicator = dojo.byId(this.WID + "colorIndicator");
		bgColorIndicator.style.backgroundColor = bgcolor;
		com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil._setTitleForColorNode(bgColorIndicator,com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_COLOR);
		var borderColorIndicator = dojo.byId(this.WID + "borderColorIndicator");
		borderColorIndicator.style.backgroundColor = pagebordercolor;
		com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil._setTitleForColorNode(borderColorIndicator,com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BORDER_COLOR);
		
		var pageBorderSelection = dojo.byId(this.WID + "pageBorder");
		pageBorderSelection.options[com.ibm.mm.builder.utils.layoutUtil.getPageBorderSelectIndex(pageborderstyle)].selected = true;
		// add title dynamically...
		pageBorderSelection.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BORDER + ":" + pageBorderSelection.options[pageBorderSelection.selectedIndex].innerHTML);
		dojo.connect(pageBorderSelection,"onchange",this,function() {
			var pageBorderSelection = dojo.byId(this.WID + "pageBorder");
			var selectedOption = pageBorderSelection.options[pageBorderSelection.selectedIndex];
			pageBorderSelection.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BORDER + ":" + selectedOption.innerHTML);
		});
		var imagePropSelection = dojo.byId(this.WID + "ImagePropSelection");
		imagePropSelection.options[com.ibm.mm.builder.utils.layoutUtil.getImagePropSelectIndex(bgiproperty)].selected = true;
		// add title dynamically...
		imagePropSelection.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROPERTIES + ":" + imagePropSelection.options[imagePropSelection.selectedIndex].innerHTML);
		dojo.connect(imagePropSelection,"onchange",this,function() {
			var imagePropSelection = dojo.byId(this.WID + "ImagePropSelection");
			var selectedOption = imagePropSelection.options[imagePropSelection.selectedIndex];
			imagePropSelection.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROPERTIES + ":" + selectedOption.innerHTML);
		});
		// init the background image Transparency option
		var bTslider = dijit.byId(this.WID + "bgiTransparency");
		if(bTslider && !init){
			bTslider.setValue(bgitransparency);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this.WID,"bgiTransparency","bgiTransparencyValue",bgitransparency,"%","100","5");
		}
		// init page margin option
		var pMslider = dijit.byId(this.WID + "pageMarginSlider");
		dojo.byId(this.WID  + "pageMarginSliderGraphic").style.width = pagemargin + "px";
		if(pMslider && !init){
			pMslider.setValue(pagemargin);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this.WID,"pageMarginSlider","pageMarginSliderValue",pagemargin,"","20","1","pageMarginSliderGraphic");
		}
	},
	
	setWidgetProperties : function(/* boolean */ init, widgetProperties){
		var skin;
		this.previousDefaultSkin = com.ibm.mm.builder.freeLayOutBean.getSelectedSkin();
		if(widgetProperties !== null){
			skin = widgetProperties.skin;
		}
		
		var applyAllusingDSTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN;
		var applyAllWidgetTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN_ALL;
	
		if (widgetProperties.applyDefaultSkinToAll=="0"){
			this.applyDSToAll = "0";
			dojo.byId(this.WID + "applyAllUsingDS").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"DefaultSkinApplyType","1","eval(" + this.WID + "iContext.iScope().selectDSApllyToExisting())",true,applyAllusingDSTitle);
			dojo.byId(this.WID + "applyAllWigets").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"DefaultSkinApplyType","0","eval(" + this.WID + "iContext.iScope().selectDSApllyToAll())",false,applyAllWidgetTitle);
		}else{
			this.applyDSToAll = "1";
			dojo.byId(this.WID + "applyAllUsingDS").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"DefaultSkinApplyType","0","eval(" + this.WID + "iContext.iScope().selectDSApllyToExisting())",false,applyAllusingDSTitle);
			dojo.byId(this.WID + "applyAllWigets").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"DefaultSkinApplyType","1","eval(" + this.WID + "iContext.iScope().selectDSApllyToAll())",true,applyAllWidgetTitle);
		}		
		com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkin(skin,this._iContext.widgetId);	
	},
		
	selectBGINone : function(){
		this.backgroundImageType = "None";
		var moreProp = dojo.byId(this.WID + "urlMoreProperties");
		moreProp.style.display = "none";
	},
		
	selectBGIURL : function(){
		this.backgroundImageType = "URL";
		var moreProp = dojo.byId(this.WID + "urlMoreProperties");
		moreProp.style.display = "";
	},
	
	selectDSApllyToExisting:function(){
		this.applyDSToAll = "0";
	},	
		
	selectDSApllyToAll:function(){
		this.applyDSToAll = "1";
	},		
		
	restoreDefaultConfiguration : function(){
		this.restoreDefaultPageConfiguration();
		this.restoreDefaultWidgetConfiguration();
	},
		
	restoreDefaultPageConfiguration : function(){
		var pageDefaultSetting = com.ibm.mm.builder.freeLayOutBean.getPageDefaultSetting();
		this.setPageProperties(false, pageDefaultSetting);
		var urlRequired = dojo.byId(this.WID + "URLRequired_text");
		urlRequired.style.display="none";
	},
	
	restoreDefaultWidgetConfiguration : function(){
		var widgetDefaultSetting = com.ibm.mm.builder.freeLayOutBean.getWidgetDefaultSetting();
		this.setWidgetProperties(false, widgetDefaultSetting);
	},
			
	showMorePageProperty : function(){
		var morePropText = dojo.byId(this.WID + "pagePropertiesMore");
		var moreProp = dojo.byId(this.WID + "pageMoreProperties");
		if (morePropText.innerHTML == com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS){
			morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE;
			dojo.attr(morePropText,"title",com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE);
			moreProp.style.display = "none";
		}else{
			morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS;
			dojo.attr(morePropText,"title",com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS);
			moreProp.style.display = "";			
		}		
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(moreProp);	
	},
	
	showMorePagePropertyWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) {
			return true;
		}		
		this.showMorePageProperty();
	},
		
	showMoreWidgetProperty : function(){
		var morePropText = dojo.byId(this.WID + "widgetPropertiesMore");
		var moreProp = dojo.byId(this.WID + "widgetMoreProperties");
		if (morePropText.innerHTML == com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS){
			morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE;
			moreProp.style.display = "none";
		}else{
			morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS;
			moreProp.style.display = "";			
		}	
	},
	
	/**
	 * toEditMode is called when user click the edit icon
	 */
	showConfiguration : function(){
		this.freeformEditPane = new com.ibm.mm.builder.widget.WidgetEditDialog({
            id: this._iContext.widgetId + "_edit",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PRO_TITLE,
            type: "config",
            nodeWidth: "520px",
            needModeSwitch: true,
            belongId: this._iContext.widgetId,
            containerBackgroundColor: "white",
            hasRightBottomResizer: false,
			closeCallback: function(){ 
				this.destroy();
			}
        });
        
		com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this._iContext.widgetId, "onModeChanged", {
            newMode: 'edit',
            rootElementId: this.freeformEditPane.containerNode
        });
		
		this.freeformEditPane.show();
	},
	
	applySettings : function(){
		var att = this._iContext.getiWidgetAttributes();
		var bgitype,bgi,bgiproperty,bgitransparency,bgcolor,pageborderstyle,pagebordercolor,pagemargin,skin;	
		if (att !== null) {
			bgitype = att.getItemValue("backgroundimagetype");
			bgi = att.getItemValue("backgroundimage");
			bgiproperty = att.getItemValue("backgroundimageproperty");
			bgitransparency = att.getItemValue("backgroundimagetransparency");
			bgcolor = att.getItemValue("pagebgcolor");
			pageborderstyle = att.getItemValue("pageborderstyle");	 
			pagebordercolor = att.getItemValue("pagebordercolor");	
			pagemargin = att.getItemValue("pagemargin");	
			skin = att.getItemValue("skin");			
		}
		
		
		//the background color should be applied to the container node when the height of layout increases
		if (bgcolor != "None") {
			dojo.byId(this.WID + "container").style.backgroundColor = bgcolor;
		} else {
			dojo.byId(this.WID + "container").style.backgroundColor = "transparent";
		}
		
		if (pagemargin != "None") {
			dojo.byId(this.WID + "freeFormTable").style.padding = pagemargin + "px";
		} else {
			dojo.byId(this.WID + "freeFormTable").style.padding = "";
		}
		
		if (pageborderstyle == "none"){
			dojo.byId(this.WID+"freeFormTable").style.border = 0;
		} else {
			dojo.byId(this.WID+"freeFormTable").style.border = pageborderstyle + " " + pagebordercolor;
		}
		
		if (bgitype == "URL"){
			dojo.byId(this.WID+"container").style.backgroundImage = com.ibm.mm.builder.utils.layoutUtil.transformBgIamge(bgi);
			if (bgiproperty == "Scale"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "no-repeat";
				dojo.byId(this.WID+"container").style.backgroundPosition = "left top";
			}
			if (bgiproperty == "RepeatX"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "repeat-x";
				dojo.byId(this.WID+"container").style.backgroundPosition = "left top";
			}
			if (bgiproperty == "RepeatY"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "repeat-y";
				dojo.byId(this.WID+"container").style.backgroundPosition = "left top";
			}
			if (bgiproperty == "Repeat"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "repeat";
			}		
			if (bgiproperty == "Center"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "no-repeat";
				dojo.byId(this.WID+"container").style.backgroundPosition = "top center";
			}		
			bgitransparency = 100 - bgitransparency;								
			dojo.byId(this.WID+"container").style.opacity = parseInt(bgitransparency,10)/100;	
			dojo.byId(this.WID+"container").style.filter = "alpha(opacity=" + bgitransparency + ")";
		} else {
			dojo.byId(this.WID+"container").style.backgroundImage = "";
			dojo.byId(this.WID+"container").style.backgroundRepeat = "";
			dojo.byId(this.WID+"container").style.backgroundPosition = "";
			// fix 1713
			// When there is background image, it should not be removed, just set it transparent.
			// When there is no background image, no need to set opacity, and the opacity should only be set once.
			/*
			if(dojo.isIE) {
				if(dojo.byId(this.WID+"container").style.backgroundImage == "none"
						|| dojo.byId(this.WID+"container").style.backgroundImage == "") {
				} else {
					if(dojo.byId(this.WID+"container").style.filter!="")
						dojo.byId(this.WID+"container").style.filter = "alpha(opacity=0)";
				}
					
			} else {
				dojo.byId(this.WID+"container").style.backgroundImage = "none";
			}
			*/
		}
	},
		
	/**
	 * show the page background color picker
	 */	
	showPageBgColorPicker : function(){
		if (this.backgroundImageType == "URL") {
			return;
		}
		var indicatorX = dojo._abs(dojo.byId(this.WID+"colorIndicator")).x;
		var indicatorY = dojo._abs(dojo.byId(this.WID+"colorIndicator")).y;
		var relativeX = indicatorX - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).x + this.colorPickerAdjustPosX;
		var relativeY = indicatorY - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).y + this.colorPickerAdjustPosY;
		this._showColorPalette(this.WID+"colorIndicator",relativeX,relativeY);	
	},
		
	showPageBorderColorPicker : function(){
		if (dojo.byId(this.WID + "pageBorder").selectedIndex === 0) {
			return;
		}
		var indicatorX = dojo._abs(dojo.byId(this.WID+"borderColorIndicator")).x;
		var indicatorY = dojo._abs(dojo.byId(this.WID+"borderColorIndicator")).y;
		var relativeX = indicatorX - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).x + this.colorPickerAdjustPosX;
		var relativeY = indicatorY - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).y + this.colorPickerAdjustPosY;
		this._showColorPalette(this.WID+"borderColorIndicator",relativeX,relativeY);
	},
			
	/**
	 * this function is called to show the color picker
	 */
	_showColorPalette : function(indicatorId,posX,posY){
		var rtlColorPaletteAdjust = 0;
		var palette = "8x16";		
		var father = dojo.byId(this.WID+"ColorPaletteContainer");
		var indicator = dojo.byId(indicatorId);
		var colorPaletteX = posX;
		var colorPaletteY = posY;
		if (this.colorPicker!==null){
			this.colorPicker.destroy();
			var colorPalette = document.createElement("div");
			colorPalette.id = this.WID+"ColorPalette";
			father.appendChild(colorPalette);
		}
		if (dojo.version.major == 1 && dojo.version.minor == 4){
			// dojo 1.4
			this.colorPicker = new com.ibm.mm.builder.widget.MumColorPalette14({
				palette:palette,
				indicator:indicatorId
			}, dojo.byId(this.WID+"ColorPalette"));			
		}else{
			this.colorPicker = new com.ibm.mm.builder.widget.MumColorPalette({
				palette:palette,
				indicator:indicatorId
			}, dojo.byId(this.WID+"ColorPalette"));			
		}
		if(builderConfig.isBidi){
			var str = this.colorPicker._paletteDims[palette].width;
			str=str.replace(/px/,"");
			//18 is size of preview color div box width + a pixel more for looks
			rtlColorPaletteAdjust = new Number(str)-19;//JSLINT-IGNORE: deprecated code for mashups 3.0
		}
		father.style.left = colorPaletteX - rtlColorPaletteAdjust + "px";
		father.style.top = colorPaletteY + "px";
		father.style.zIndex = 888;		
		father.style.display = "";
		this.colorPicker.focus();
	},
		
	cancelInput : function(){
		com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this._iContext.widgetId, "onModeChanged", {newMode:'view'});
		
		var att = this._iContext.getiWidgetAttributes();
		var skinFromAttr = att.getItemValue("skin");
		com.ibm.mm.builder.freeLayOutBean.setSelectedSkin(skinFromAttr);
	},
		
	validateInput : function(){
		if (this.backgroundImageType == "URL") {
			var urlvalue = dojo.byId(this.WID + "pageBgImageURL_input").value;
			if (dojo.trim(urlvalue) == ""){
				dojo.byId(this.WID + "URLRequired_text").style.display = "";
				return false;
			}else{
				dojo.byId(this.WID + "URLRequired_text").style.display = "none";
				return true;
			}
		}	
		return true;			
	},
		
	/**
	 * saveInput is called when click the save button in configuration pane
	 * things to do in saveInput:
	 * 1. save and update the itemsets in page fragment
	 * 2. save the itemsets in page metadata
	 * 3. hide the configuration pane
	 */
	saveInput : function(){
		if (!this.validateInput()) {
			return;
		}
		// update attribute	
		var att = this._iContext.getiWidgetAttributes();
		att.setItemValue("skin", com.ibm.mm.builder.freeLayOutBean.getSelectedSkin(), false);
		att.setItemValue("backgroundimagetype", this.backgroundImageType, false);
		if (this.backgroundImageType === "URL") {
			att.setItemValue("backgroundimage", dojo.byId(this.WID + "pageBgImageURL_input").value, false);
		}
		att.setItemValue("backgroundimageproperty", dojo.byId(this.WID + "ImagePropSelection").value, false);
		
		var bgiTrans = dojo.byId(this.WID + "bgiTransparencyValue").innerHTML;
		var bgiTransAttr = parseInt(bgiTrans,10) + "";
		att.setItemValue("backgroundimagetransparency", bgiTransAttr, false);
		att.setItemValue("pagebgcolor", dojo.byId(this.WID + "colorIndicator").style.backgroundColor, false);
		att.setItemValue("pageborderstyle", dojo.byId(this.WID + "pageBorder").value, false);
		att.setItemValue("pagebordercolor", dojo.byId(this.WID + "borderColorIndicator").style.backgroundColor, false);
		att.setItemValue("applyDefaultSkinToAll", this.applyDSToAll, false);
		
		var pageMargin = dojo.byId(this.WID + "pageMarginSliderValue").innerHTML;
		var pageMarginAttr = parseInt(pageMargin,10) + "";
		att.setItemValue("pagemargin", pageMarginAttr, false);
		att.save();
		
		// Change the widget skins on canvas
		this.changeWidgetSkin();
		
		this.previousDefaultSkin = com.ibm.mm.builder.freeLayOutBean.getSelectedSkin();
		
		var jsonStr=com.ibm.mm.builder.utils.iwidgetUtil.dumpItemSetsToJSON(att);
		com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData(dojo.fromJson(jsonStr));
		
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this._iContext.widgetId, "onModeChanged", {newMode:'view'});
	},
	
	savePageWidthMode : function(pageWidthMode) {
		var att = this._iContext.getiWidgetAttributes();
		att.setItemValue("pageWidthMode", pageWidthMode.mode, false);
		att.setItemValue("pageWidth", pageWidthMode.width, false);
		att.save();
		com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData({
			pageWidthMode: pageWidthMode.mode,
			pageWidth: pageWidthMode.width
		});
	},
	
    changeWidgetSkin: function(){
		dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, this.WID + "container").forEach(function(widgetSpan){
			if (this.applyDSToAll == 1 || (this.applyDSToAll === 0 && 
				widgetSpan.getAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin) === this.previousDefaultSkin)) {
                
				widgetSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, com.ibm.mm.builder.freeLayOutBean.getSelectedSkin());
                
				var widgetSkin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetSpan.id);
				var skinBox = dojo.marginBox(widgetSkin);
                var locationStyle = dojo.string.substitute(
					"position:absolute;width:${w}px;height:${h}px;left:${l}px;top:${t}px;", skinBox);
                if (widgetSkin.style.zIndex) {
					locationStyle += "z-Index:" + widgetSkin.style.zIndex + ";";
				}
                widgetSpan.setAttribute("locationstyle", locationStyle);
                com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(widgetSpan);
            }
		}, this);
    },	
				
	/**
	 * For Globalization request, set the text on the configuration UI dynamically
	 */
	fillInTheText : function(){
		dojo.parser.parse(this.freeformEditPane.domNode);
		//dojo.byId(this.WID + "restoretitle_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_TITLE;
		//dojo.byId(this.WID + "pagebackgroud_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BACKGROUND;
		dojo.byId(this.WID + "pageproperties_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_PROPERTIES;
		dojo.byId(this.WID + "pagebgimage_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BACKGROUND_IMAGE;
		dojo.byId(this.WID + "pagebgnone_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_NONE;
		dojo.byId(this.WID + "pageBgImageURL_input").title = dojo.byId(this.WID + "pagebgimageurl_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_URL;
		dojo.byId(this.WID + "URLRequired_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_URL_REQUIRED;
		dojo.byId(this.WID + "ImagePropSelection").title = dojo.byId(this.WID + "pagebgimageproperties_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROPERTIES;
		//dojo.byId(this.WID + "pagescale_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROP_SCALE;
		dojo.byId(this.WID + "pagerepeathorizontal_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROP_REPEATH;
		dojo.byId(this.WID + "pagerepeatvertical_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROP_REPEATV;
		dojo.byId(this.WID + "pagerepeatboth_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PRO_REPEATB;
		dojo.byId(this.WID + "pagecenter_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROP_CENTER;
		dojo.byId(this.WID + "pagebgimagetrans_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_TRANS;
		//dojo.byId(this.WID + "pageedge_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_EDGE;
		dojo.byId(this.WID + "pageBorder").title = dojo.byId(this.WID + "pageborder_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BORDER;
		dojo.byId(this.WID + "pagemargin_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_MARGIN;
		//dojo.byId(this.WID + "restoredefpagepro_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_DEFAULT_PAGE_PROPERTIES;
		dojo.byId(this.WID + "widgtpro_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_PROPERTIES;
		dojo.byId(this.WID + "defskinfornewwidgets_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN;
		dojo.byId(this.WID + "applyAllUsingDS_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN;
		dojo.byId(this.WID + "applyAllWigets_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN_ALL;
		
		//dojo.byId(this.WID + "widgetPropertiesMore").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE;
		//dojo.byId(this.WID + "restoredefpgpro_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_DEFAULT_PAGE_PROPERTIES;
		dojo.byId(this.WID + "pgcolor_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_COLOR;
		dojo.byId(this.WID + "pagePropertiesMore").title = dojo.byId(this.WID + "pagePropertiesMore").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE;
		
		var widthLimit = dojo.isIE ? "60" : "140";
		dojo.byId(this.WID + "restoredef_text2").value = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_BUTTON;
		dojo.attr(dojo.byId(this.WID+"restoredef_text2"),"widthLimit",widthLimit);
		dojo.byId(this.WID + "restoredef_text3").value = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_BUTTON;
		dojo.attr(dojo.byId(this.WID+"restoredef_text3"),"widthLimit",widthLimit);
		
		var charLimit=dojo.isIE?14:16;
		//dojo.byId(this.WID + "save_text").value = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE ;
		//dojo.byId(this.WID + "cancel_text").title = dojo.byId(this.WID + "cancel_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL ;
		// border style
		var borderSelect = dojo.byId(this.WID + "pageBorder");
		com.ibm.mm.builder.utils.layoutUtil.setBorderSelect(borderSelect);
		
		//for a11y
		dojo.byId(this.WID + "restoredef_text2").title = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_DEFAULT_PAGE_PROPERTIES;
		dojo.byId(this.WID + "restoredef_text3").title = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_DEFAULT_WIDGET_PROPERTIES;
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(dojo.byId(this.WID+this.currentPageMode));
	},
	
	toChangeFreeFormMode:function(){
		var configdiv = dojo.byId(this.WID+"layoutWidgetConfigDiv");
		if (configdiv){
			if (this.currentPageMode == "edit"){
				if (!dojo.isIE || dojo.isIE > 6) {
					this.configIconMouseOverHandler = dojo.connect(dojo.byId(this.WID+"freeFormTable").parentNode, "onmouseover", this, "showConfigurationIcon");
					this.configIconMouseOutHandler = dojo.connect(dojo.byId(this.WID+"freeFormTable").parentNode, "onmouseout", this, "hideConfigurationIcon");
					this.configIconOnFocusHandler = dojo.connect(dojo.byId(this.WID+"freeFormTable"), "onkeypress", this, "showConfigurationIcon");
				} 
				configdiv.style.display = "";
			}else{	
				if (!dojo.isIE || dojo.isIE > 6) {
					dojo.disconnect(this.configIconMouseOverHandler);
					dojo.disconnect(this.configIconMouseOutHandler);
					dojo.disconnect(this.configIconOnFocusHandler);
				}
				configdiv.style.display = "none";
			}
		}
	}
});

}
