if(!dojo._hasResource["com.ibm.mm.builder.widget.ViewMorePage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ViewMorePage"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 * @author ERiK (bizheng@cn.ibm.com)
 */
//todo refactory the html structure..
dojo.provide("com.ibm.mm.builder.widget.ViewMorePage");

dojo.declare("com.ibm.mm.builder.widget.ViewMorePage",
	[dijit._Widget,dijit._Templated, dijit._Container], 
{
	templateString: '<div><div dojoAttachPoint="containerNode"></div></div>',
	
	postCreate: function() {
		this.pageList = [];
		dojo.forEach(this.items, function(item) {
			this.addChild(new com.ibm.mm.builder.widget.ViewMorePageItem({
				title: item.title,
				pid: item.pid,
				pre: item.pre,
				end: item.end
			}));
		}, this);
	},
	
	reGenerate: function(items) {
		this.pageList = [];
		this.items = items;
		this.destroyDescendants();
		dojo.forEach(this.items, function(item) {
			this.addChild(new com.ibm.mm.builder.widget.ViewMorePageItem({
				title: item.title,
				pid: item.pid,
				pre: item.pre,
				end: item.end
			}));
		}, this);
	}
});

dojo.declare("com.ibm.mm.builder.widget.ViewMorePageItem",
	[dijit._Widget,dijit._Templated, dijit._Container, dijit._Contained],
{
	templateString_rtl:
			'<div style="height:25px" waiRole="presentation">' +
			'<div dojoAttachPoint="treeItemDividerTop" class="treeItemDividerTop"></div>'+
			'<div dojoAttachPoint="contentNode" class="pageItemContent" dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover" waiRole="presentation">' +
		        '<span style="float:right" dojoAttachPoint="iconNode" waiRole="presentation">' +
		        '</span>' +
		        '<span style="float:right" dojoAttachPoint="labelDescNodePre" class="treeItemDesc treeItemDescPreLoc"></span>' +
		        '<span style="float:right" dojoAttachPoint="labelNode" class="treeItemText" role="listitem" tabindex="0"></span>' +
		    	'<span style="float:right" dojoAttachPoint="labelDescNode" class="treeItemDesc treeItemDescLoc"></span>' +
		    	'<span style="padding:0px 20px;float:left">' +
			    	'<input dojoAttachPoint="btnAddNode" class="sharingPageTreeButton" type="button" value="" dojoAttachEvent="onclick:_onAddClick"/>' +
			    	'<input style="display:none" class="sharingPageTreeButton" dojoAttachPoint="btnRemoveNode" type="button" value="" dojoAttachEvent="onclick:_onRemoveClick"/>' +
		    	'</span>' +
		    '</div>'+
			'<div dojoAttachPoint="treeItemDividerBottom" class="treeItemDividerBottom"></div>'+
		'</div>',

	templateString:
		'<div style="height:25px" waiRole="presentation">' +
			'<div dojoAttachPoint="treeItemDividerTop" class="treeItemDividerTop"></div>'+
			'<div dojoAttachPoint="contentNode" class="pageItemContent" dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover" waiRole="presentation">' +
		        '<span style="float:left" dojoAttachPoint="iconNode" waiRole="presentation">' +
		        '</span>' +
		        '<span style="float:left" dojoAttachPoint="labelDescNodePre" class="treeItemDesc treeItemDescPreLoc"></span>' +
		        '<span style="float:left" dojoAttachPoint="labelNode" class="treeItemText" role="listitem" tabindex="0"></span>' +
		    	'<span style="float:left" dojoAttachPoint="labelDescNode" class="treeItemDesc treeItemDescLoc"></span>' +
		    	'<span style="padding:0px 20px;float:right">' +
			    	'<input dojoAttachPoint="btnAddNode" class="sharingPageTreeButton" type="button" value="" dojoAttachEvent="onclick:_onAddClick"/>' +
			    	'<input style="display:none" class="sharingPageTreeButton" dojoAttachPoint="btnRemoveNode" type="button" value="" dojoAttachEvent="onclick:_onRemoveClick"/>' +
		    	'</span>' +
		    '</div>'+
			'<div dojoAttachPoint="treeItemDividerBottom" class="treeItemDividerBottom"></div>'+
		'</div>',
		
	postMixInProperties: function() {
		if (builderConfig.isBidi) {
			this.templateString = this.templateString_rtl;
		}
	},
	
	postCreate: function() {
		this.labelDescNodePre.innerHTML = this.pre;
		this.labelDescNode.innerHTML = this.end;
		this.labelNode.innerHTML = this.title;
		this.domNode.title = com.ibm.mm.builder.utils.htmlUtil.unEscapeString(this.title);
		this.btnAddNode.value = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_ADD;
		this.btnRemoveNode.value = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_REMOVE;
		this._changeToAdd();	
	},
	
	_onHover: function() {
		dojo.addClass(this.domNode, "highLightTreeItem");
		dojo.addClass(this.labelNode, "highLightTreeText");
		this.treeItemDividerTop.style.backgroundImage = "url('" + builderConfig.builderPath + "/images/divider_morepages_hover_top.png')";
	},
	
	_onUnhover: function(){	
		dojo.removeClass(this.domNode,"highLightTreeItem");
		dojo.removeClass(this.labelNode,"highLightTreeText");
		this.treeItemDividerTop.style.backgroundImage = "";
	},
	
	_changeToAdd: function(){
		this.labelNode.style.color = "#000000";
		this.labelNode.style.fontSize = "12px";
		this.labelNode.fontFamily = "Arial";
		this.btnAddNode.style.display = "";
		this.btnRemoveNode.style.display = "none";
	},
	
	_changeToRemove: function(){
		this.labelNode.style.color = "#BDBDD3";
		this.btnAddNode.style.display = "none";
		this.btnRemoveNode.style.display = "";
	},
	
	_onRemoveClick: function(){
		this._changeToAdd();
		this.removeItem(this.getParent().pageList,this.pid);
	},
	
	removeItem: function(array, value) {
		for (var i = 0, n = 0; i < array.length; i++) {
			if (array[i] != value) {
				array[n++] = array[i];
			}
		}
		array.length -= 1;
	},
	
	_onAddClick: function(){
		this._changeToRemove();
		this.getParent().pageList.push(this.pid);
	}
});



}
