if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification"] = true;
/**
 * @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");

dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification", [dijit._Widget, dijit._Templated], {
	
	autoWiringResult: null,
	
	contentRoot: null,
	
	notificationDialog:null,
	
	widgetId: null,
	
	location:null,
	
	templateString: "<div dojoAttachPoint='autoWiringNotiDiv' class='mumAutoWiringNotiDiv'>" +
						"<div dojoAttachPoint='autoWiringNotiDivMain' class='mumAutoWiringNotiDivMain'>"+
							"<div dojoAttachPoint='titleNode' class='mumAutoWiringTitle'>" +
								"<span dojoAttachPoint='titleIconNode' class='mumAutoWiringTitleIcon'>" + 
								"</span>" +
								"<span dojoAttachPoint='titleText' class='mumAutoWiringTitleText'>" + 
								"</span>" +
							"</div>" +
							"<div dojoAttachPoint='contentNode' class='mumAutoWiringContent'>" +
							"</div>" +
							"<div dojoAttachPoint='actionsNode' class='mumAutoWiringActions'>" +
								"<div dojoAttachPoint='openWiringNode' class='mumAutoWiringOpenWiring'>" + 
								"</div>" +
								"<div dojoAttachPoint='NotiCfgNode' class='mumAutoWiringNotiCfg'>" + 
									"<input type='checkbox' dojoAttachPoint='NotiCfgCheckNode' dojoAttachEvent='onclick: onNotifyMeClicked' class='mumAutoWiringNotiCfgCheck'/>" +
									"<div dojoAttachPoint='NotiCfgLabel' class='mumAutoWiringNotiCfgLable'></div>" +
								"</div>" +
							"</div>" +
						"</div>" +
						"<div dojoAttachPoint='okNode' class='mumAutoWiringOk'>" +
							"<div dojoAttachPoint='okTextHidden' class='mumAutoWiringOKTextHidden'>" + 
							"</div>"+
							"<div dojoAttachPoint='okText' class='mumAutoWiringOKText'>" + 
							"</div>"+
						"</div>" +
					"</div>",
						
	constructor: function(){
		
	},
	
	onNotifyMeClicked:function(event){
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {
			var userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
			var user = userModel.findCurrentUser().start();
			user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS", !this.NotiCfgCheckNode.checked);
			userModel.commit().start();
		}
	},
	
	onClickOpenWiring:function(){
		var widgetId = this.autoWiringResult.widgetId;
		var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		var widgetIcon = widgetUtil.getWidgetIconCSA2(widgetId);
		var dialogParam = {
			nodeWidth: "486px",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME,
			titleIconUrl: widgetIcon,
			leftBarWidth: "18px",
			rightBarWidth: "12px",
			displayCloseButton: true,
			hasRightBottomResizer: false
		};
		var payload = {
	    	widgetTypeId: "wireInterface",
	        eventName:  "com.ibm.mashups.builder.editWire",
	        eventPayload:  widgetId,
	        dialogParam:  dialogParam,
			hasRightBottomResizer: false,
	        requestRefresh: true
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	initContent:function(){
		this.fillInText();
		if (!this.autoWiringResult) {
			return;
		}
		
		this.titleIconNode.innerHTML = "";
		var wiringIcon = document.createElement("img");	
		this.titleIconNode.appendChild(wiringIcon);
		wiringIcon.alt = wiringIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME;
		dojo.attr(wiringIcon,"src",builderConfig.builderPath + (builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png":"/images/d_wiring_icon.png"));	
		
		
		this.contentNode.innerHTML = "";
		var publishToWidgets = this.autoWiringResult.publishTo;
		var receiveFromWidgets = this.autoWiringResult.receiveFrom;
		var wireDiv=null;
		for(var i = 0; i < publishToWidgets.length; i++) {
			wireDiv = this.createWireDiv(publishToWidgets[i],"Send");
			this.contentNode.appendChild(wireDiv);
		}
		for(var j = 0; j < receiveFromWidgets.length; j++) {
			 wireDiv = this.createWireDiv(receiveFromWidgets[j],"Receive");
			this.contentNode.appendChild(wireDiv);
		}
		dojo.connect(this.openWiringNode,"onclick", this,"onClickOpenWiring");
		dojo.connect(this.okText,"onclick", this,"hide");
	},
	
	hide:function(){
		var notificationDlg = dijit.byId("Mashup_Auto_Wiring_Notification_Dlg" + this.widgetId);
		if(notificationDlg) {
			notificationDlg.hide();
			notificationDlg.destroy();
		}
	},
	
	createWireDiv:function(widgetId,type) {
		//var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		var widgetIconUrl = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetIconCSA2(widgetId);
		var wireDiv = document.createElement("div");
		dojo.addClass(wireDiv,"mumAutoWiringWireDiv");
		var iconDiv = document.createElement("div");
		wireDiv.appendChild(iconDiv);
		dojo.addClass(iconDiv,"mumAWWireDivIcon");

		var widgetIcon = document.createElement("img");
		iconDiv.appendChild(widgetIcon);
		
		widgetIcon.alt = widgetIcon.title= com.ibm.mm.builder.utils.htmlUtil.unEscapeString(widgetTitle);	
		dojo.attr(widgetIcon,"src",widgetIconUrl);	
		
		var textDiv = document.createElement("div");
		wireDiv.appendChild(textDiv);
		dojo.addClass(textDiv,"mumAWWireDivText");
		
		if(type == "Send") {
			textDiv.innerHTML = textDiv.title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_SENDING_TO,[widgetTitle]);
		}
		else {
			textDiv.innerHTML = textDiv.title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_RECEIVING_FROM,[widgetTitle]);
		}
		return wireDiv;
	},
	
	fillInText:function(){
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		if (this.location.inNVA) {
			this.titleText.innerHTML = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_TITLE_FOR_WIDGET, [widgetTitle]);
		}
		else {
			this.titleText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_TITLE;
		}
		this.openWiringNode.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_OPEN_WIRE_INTERFACE + "</a>";
		this.NotiCfgLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_DISABLE_NOTI;
		this.okText.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		this.okTextHidden.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
	},
	
	/**
	 * show the access control reassign dialog
	 */
	showAutoWiringResult: function(id,autoWiringResult,location){
		this.widgetId = id;
		this.autoWiringResult = autoWiringResult;
		this.location = location;
		
		dojo.subscribe("widgetDeleted"+id,this,"hide");
		
		this.initContent();
		var notificationDlg = dijit.byId("Mashup_Auto_Wiring_Notification_Dlg" + this.widgetId);
		if (notificationDlg){
			notificationDlg.destroy();
		}
		var contentDiv = document.createElement("div");
		contentDiv.appendChild(this.autoWiringNotiDiv);
		
		this.notificationDialog = new com.ibm.mm.builder.widget.CustomDialog(
			{
				id: "Mashup_Auto_Wiring_Notification_Dlg"+this.widgetId,
				needUnderLay:false,
				roundCorner:true,
				modelDialog:false,
				initLeftPosition:location.x+"px",
				initTopPosition:location.y+"px",
				hasRightBottomResizer: false,
				dialogOpacity: 0.85
			},
			contentDiv
		);
		this.notificationDialog.show();
	}
});

}
